<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html><head><meta http-equiv="Content-Type" content="text/html;charset=iso-8859-1">
<title>ESM Driver</title>
<link href="doxygen.css" rel="stylesheet" type="text/css">
<link href="tabs.css" rel="stylesheet" type="text/css">
</head><body>
<table width=100%>
<tr>
  <td bgcolor="black" width="1"><a href="http://www.ti.com"><img border=0 src="../../tilogo.gif"></a></td>
  <td bgcolor="red"><img src="../../titagline.gif"></td>
</tr>
</table>
<!-- Generated by Doxygen 1.8.11 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li class="current"><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="annotated.html"><span>Data&#160;Structures</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
    </ul>
  </div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">ESM Driver </div>  </div>
</div><!--header-->
<div class="contents">
<div class="textblock"><p>The ESM driver provides APIs to configure and handle errors coming from the ESM H/W module</p>
<p>The ESM header file should be included in an application as follows: </p><div class="fragment"><div class="line"><span class="preprocessor">#include &lt;<a class="code" href="esm_8h.html">ti/drivers/esm/esm.h</a>&gt;</span></div></div><!-- fragment --><h2>Initializing the driver</h2>
<p>The ESM Driver is initialized using the <a class="el" href="group___e_s_m___d_r_i_v_e_r___e_x_t_e_r_n_a_l___f_u_n_c_t_i_o_n.html#ga24964b4191ac0a77a5a66d1693c33765" title="Function intializes the ESM driver. ">ESM_init</a>. None of the ESM API can be used without invoking this API. <br />
 <b>Note</b>: If you using TI RTOS, then ESM errors are cleared before entering main and this flag can be set to 0. For any other RTOS, check the the RTOS implementation or set this flag to 1</p>
<h2>Using the driver</h2>
<p>Following is a psuedo code for using the ESM driver</p>
<div class="fragment"><div class="line"><a class="code" href="group___e_s_m___d_r_i_v_e_r___e_x_t_e_r_n_a_l___f_u_n_c_t_i_o_n.html#ga24964b4191ac0a77a5a66d1693c33765">ESM_init</a>(0); <span class="comment">//ClearErrors is set to 0 i.e. false</span></div></div><!-- fragment --><h2>Handling Interrupts on MSS</h2>
<p>The ESM drivers when run on R4F, registers for high priority FIQ to handle the MSS ESM errors. When ESM errors occurs on DSS, the MSS is notified via a Group2 error signal. The ESM driver registers for low priority IRQ to handle these errors.</p>
<h2>Handling Interrupts on DSS</h2>
<p>The DSS ESM errors have to be unmasked for them to generate an NMI. Note: This is applicable for xWR16xx DSS only. The API #SOC_configureDSSESMMask is provided. Drivers/Applications will have to unmask the bits for the error signals it is interested in. e.g., Watchdog driver internally unmasks the watchdog expiry NMI error bits to generate the NMI.</p>
<p>The DSS ESM errors generate a NMI that is first captured by the RTOS NMI exception handler. Hence applications have to populate the NMI exception handler to use the ESM driver's high priority FIQ processing API in the .cfg file.</p>
<div class="fragment"><div class="line">Exception.nmiHook           = <span class="stringliteral">&quot;&amp;ESM_highpriority_FIQ&quot;</span>;</div></div><!-- fragment --><h2>Registering the notifiers</h2>
<p>The application can register callback functions for the ESM errors that need additional handling. One such example is the watch dog timeout on the DSS. When the watchdog timeout causes a NMI to occur on DSS, that event inturn generates a group1 ESM error on the MSS. The application can register a callback using the ESM notifier to handle these errors.</p>
<h2>Instrumentation</h2>
<p>Uses DebugP_log functions for debug messages</p>
<h2>Hardware Register Map</h2>
<p>The hardware register map used by this driver can be found at <a class="el" href="reg__esm_8h.html" title="This file gives register definitions of MSS_ESM module. ">include/reg_esm.h</a> </p><hr/>
 </div></div><!-- contents -->
<hr size="1"><small>
Copyright  2018, Texas Instruments Incorporated</small>
</body>
</html>
